package com.hai.dao;

import com.hai.entity.ApiProduct;
import com.hai.entity.ApiProductExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface ApiProductMapper extends ApiProductMapperExt {
    @SelectProvider(type=ApiProductSqlProvider.class, method="countByExample")
    long countByExample(ApiProductExample example);

    @DeleteProvider(type=ApiProductSqlProvider.class, method="deleteByExample")
    int deleteByExample(ApiProductExample example);

    @Delete({
        "delete from api_product",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into api_product (recharge_type, recharge_platform, ",
        "phone_recharge_type, operator_type, ",
        "recharge_price, product_id, ",
        "sort, operator_id, ",
        "operator_name, create_time, ",
        "update_time, `status`, ",
        "ext_1, ext_2, ext_3)",
        "values (#{rechargeType,jdbcType=INTEGER}, #{rechargePlatform,jdbcType=VARCHAR}, ",
        "#{phoneRechargeType,jdbcType=INTEGER}, #{operatorType,jdbcType=INTEGER}, ",
        "#{rechargePrice,jdbcType=DECIMAL}, #{productId,jdbcType=BIGINT}, ",
        "#{sort,jdbcType=INTEGER}, #{operatorId,jdbcType=BIGINT}, ",
        "#{operatorName,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{status,jdbcType=INTEGER}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(ApiProduct record);

    @InsertProvider(type=ApiProductSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(ApiProduct record);

    @SelectProvider(type=ApiProductSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="recharge_type", property="rechargeType", jdbcType=JdbcType.INTEGER),
        @Result(column="recharge_platform", property="rechargePlatform", jdbcType=JdbcType.VARCHAR),
        @Result(column="phone_recharge_type", property="phoneRechargeType", jdbcType=JdbcType.INTEGER),
        @Result(column="operator_type", property="operatorType", jdbcType=JdbcType.INTEGER),
        @Result(column="recharge_price", property="rechargePrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="product_id", property="productId", jdbcType=JdbcType.BIGINT),
        @Result(column="sort", property="sort", jdbcType=JdbcType.INTEGER),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<ApiProduct> selectByExample(ApiProductExample example);

    @Select({
        "select",
        "id, recharge_type, recharge_platform, phone_recharge_type, operator_type, recharge_price, ",
        "product_id, sort, operator_id, operator_name, create_time, update_time, `status`, ",
        "ext_1, ext_2, ext_3",
        "from api_product",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="recharge_type", property="rechargeType", jdbcType=JdbcType.INTEGER),
        @Result(column="recharge_platform", property="rechargePlatform", jdbcType=JdbcType.VARCHAR),
        @Result(column="phone_recharge_type", property="phoneRechargeType", jdbcType=JdbcType.INTEGER),
        @Result(column="operator_type", property="operatorType", jdbcType=JdbcType.INTEGER),
        @Result(column="recharge_price", property="rechargePrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="product_id", property="productId", jdbcType=JdbcType.BIGINT),
        @Result(column="sort", property="sort", jdbcType=JdbcType.INTEGER),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    ApiProduct selectByPrimaryKey(Long id);

    @UpdateProvider(type=ApiProductSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") ApiProduct record, @Param("example") ApiProductExample example);

    @UpdateProvider(type=ApiProductSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") ApiProduct record, @Param("example") ApiProductExample example);

    @UpdateProvider(type=ApiProductSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(ApiProduct record);

    @Update({
        "update api_product",
        "set recharge_type = #{rechargeType,jdbcType=INTEGER},",
          "recharge_platform = #{rechargePlatform,jdbcType=VARCHAR},",
          "phone_recharge_type = #{phoneRechargeType,jdbcType=INTEGER},",
          "operator_type = #{operatorType,jdbcType=INTEGER},",
          "recharge_price = #{rechargePrice,jdbcType=DECIMAL},",
          "product_id = #{productId,jdbcType=BIGINT},",
          "sort = #{sort,jdbcType=INTEGER},",
          "operator_id = #{operatorId,jdbcType=BIGINT},",
          "operator_name = #{operatorName,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(ApiProduct record);
}