package com.hai.dao;

import com.hai.entity.HighGasClassGroup;
import com.hai.entity.HighGasClassGroupExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighGasClassGroupMapper extends HighGasClassGroupMapperExt {
    @SelectProvider(type=HighGasClassGroupSqlProvider.class, method="countByExample")
    long countByExample(HighGasClassGroupExample example);

    @DeleteProvider(type=HighGasClassGroupSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighGasClassGroupExample example);

    @Delete({
        "delete from high_gas_class_group",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_gas_class_group (merchant_store_id, merchant_store_name, ",
        "`name`, principal_name, ",
        "principal_phone, `status`, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{merchantStoreId,jdbcType=BIGINT}, #{merchantStoreName,jdbcType=VARCHAR}, ",
        "#{name,jdbcType=VARCHAR}, #{principalName,jdbcType=VARCHAR}, ",
        "#{principalPhone,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighGasClassGroup record);

    @InsertProvider(type=HighGasClassGroupSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighGasClassGroup record);

    @SelectProvider(type=HighGasClassGroupSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="merchant_store_id", property="merchantStoreId", jdbcType=JdbcType.BIGINT),
        @Result(column="merchant_store_name", property="merchantStoreName", jdbcType=JdbcType.VARCHAR),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="principal_name", property="principalName", jdbcType=JdbcType.VARCHAR),
        @Result(column="principal_phone", property="principalPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighGasClassGroup> selectByExample(HighGasClassGroupExample example);

    @Select({
        "select",
        "id, merchant_store_id, merchant_store_name, `name`, principal_name, principal_phone, ",
        "`status`, create_time, update_time, ext_1, ext_2, ext_3",
        "from high_gas_class_group",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="merchant_store_id", property="merchantStoreId", jdbcType=JdbcType.BIGINT),
        @Result(column="merchant_store_name", property="merchantStoreName", jdbcType=JdbcType.VARCHAR),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="principal_name", property="principalName", jdbcType=JdbcType.VARCHAR),
        @Result(column="principal_phone", property="principalPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighGasClassGroup selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighGasClassGroupSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighGasClassGroup record, @Param("example") HighGasClassGroupExample example);

    @UpdateProvider(type=HighGasClassGroupSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighGasClassGroup record, @Param("example") HighGasClassGroupExample example);

    @UpdateProvider(type=HighGasClassGroupSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighGasClassGroup record);

    @Update({
        "update high_gas_class_group",
        "set merchant_store_id = #{merchantStoreId,jdbcType=BIGINT},",
          "merchant_store_name = #{merchantStoreName,jdbcType=VARCHAR},",
          "`name` = #{name,jdbcType=VARCHAR},",
          "principal_name = #{principalName,jdbcType=VARCHAR},",
          "principal_phone = #{principalPhone,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighGasClassGroup record);
}