package com.hai.dao;

import com.hai.entity.HighMerchantStoreAccount;
import com.hai.entity.HighMerchantStoreAccountExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighMerchantStoreAccountMapper extends HighMerchantStoreAccountMapperExt {
    @SelectProvider(type=HighMerchantStoreAccountSqlProvider.class, method="countByExample")
    long countByExample(HighMerchantStoreAccountExample example);

    @DeleteProvider(type=HighMerchantStoreAccountSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighMerchantStoreAccountExample example);

    @Delete({
        "delete from high_merchant_store_account",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_merchant_store_account (store_id, account_no, ",
        "amounts, amounts_early_warning, ",
        "amounts_early_warning_status, `status`, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{storeId,jdbcType=BIGINT}, #{accountNo,jdbcType=VARCHAR}, ",
        "#{amounts,jdbcType=DECIMAL}, #{amountsEarlyWarning,jdbcType=DECIMAL}, ",
        "#{amountsEarlyWarningStatus,jdbcType=BIT}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighMerchantStoreAccount record);

    @InsertProvider(type=HighMerchantStoreAccountSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighMerchantStoreAccount record);

    @SelectProvider(type=HighMerchantStoreAccountSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="store_id", property="storeId", jdbcType=JdbcType.BIGINT),
        @Result(column="account_no", property="accountNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="amounts", property="amounts", jdbcType=JdbcType.DECIMAL),
        @Result(column="amounts_early_warning", property="amountsEarlyWarning", jdbcType=JdbcType.DECIMAL),
        @Result(column="amounts_early_warning_status", property="amountsEarlyWarningStatus", jdbcType=JdbcType.BIT),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighMerchantStoreAccount> selectByExample(HighMerchantStoreAccountExample example);

    @Select({
        "select",
        "id, store_id, account_no, amounts, amounts_early_warning, amounts_early_warning_status, ",
        "`status`, create_time, update_time, ext_1, ext_2, ext_3",
        "from high_merchant_store_account",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="store_id", property="storeId", jdbcType=JdbcType.BIGINT),
        @Result(column="account_no", property="accountNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="amounts", property="amounts", jdbcType=JdbcType.DECIMAL),
        @Result(column="amounts_early_warning", property="amountsEarlyWarning", jdbcType=JdbcType.DECIMAL),
        @Result(column="amounts_early_warning_status", property="amountsEarlyWarningStatus", jdbcType=JdbcType.BIT),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighMerchantStoreAccount selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighMerchantStoreAccountSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighMerchantStoreAccount record, @Param("example") HighMerchantStoreAccountExample example);

    @UpdateProvider(type=HighMerchantStoreAccountSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighMerchantStoreAccount record, @Param("example") HighMerchantStoreAccountExample example);

    @UpdateProvider(type=HighMerchantStoreAccountSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighMerchantStoreAccount record);

    @Update({
        "update high_merchant_store_account",
        "set store_id = #{storeId,jdbcType=BIGINT},",
          "account_no = #{accountNo,jdbcType=VARCHAR},",
          "amounts = #{amounts,jdbcType=DECIMAL},",
          "amounts_early_warning = #{amountsEarlyWarning,jdbcType=DECIMAL},",
          "amounts_early_warning_status = #{amountsEarlyWarningStatus,jdbcType=BIT},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighMerchantStoreAccount record);
}