package com.hai.dao;

import com.hai.entity.OutRechargeChildOrder;
import com.hai.entity.OutRechargeChildOrderExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface OutRechargeChildOrderMapper extends OutRechargeChildOrderMapperExt {
    @SelectProvider(type=OutRechargeChildOrderSqlProvider.class, method="countByExample")
    long countByExample(OutRechargeChildOrderExample example);

    @DeleteProvider(type=OutRechargeChildOrderSqlProvider.class, method="deleteByExample")
    int deleteByExample(OutRechargeChildOrderExample example);

    @Delete({
        "delete from out_recharge_child_order",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into out_recharge_child_order (parent_order_id, order_no, ",
        "recharge_platform, update_time, ",
        "create_time, `status`, ",
        "ext_1, ext_2, ext_3)",
        "values (#{parentOrderId,jdbcType=BIGINT}, #{orderNo,jdbcType=VARCHAR}, ",
        "#{rechargePlatform,jdbcType=INTEGER}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{status,jdbcType=INTEGER}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(OutRechargeChildOrder record);

    @InsertProvider(type=OutRechargeChildOrderSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(OutRechargeChildOrder record);

    @SelectProvider(type=OutRechargeChildOrderSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="parent_order_id", property="parentOrderId", jdbcType=JdbcType.BIGINT),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="recharge_platform", property="rechargePlatform", jdbcType=JdbcType.INTEGER),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<OutRechargeChildOrder> selectByExample(OutRechargeChildOrderExample example);

    @Select({
        "select",
        "id, parent_order_id, order_no, recharge_platform, update_time, create_time, ",
        "`status`, ext_1, ext_2, ext_3",
        "from out_recharge_child_order",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="parent_order_id", property="parentOrderId", jdbcType=JdbcType.BIGINT),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="recharge_platform", property="rechargePlatform", jdbcType=JdbcType.INTEGER),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    OutRechargeChildOrder selectByPrimaryKey(Long id);

    @UpdateProvider(type=OutRechargeChildOrderSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") OutRechargeChildOrder record, @Param("example") OutRechargeChildOrderExample example);

    @UpdateProvider(type=OutRechargeChildOrderSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") OutRechargeChildOrder record, @Param("example") OutRechargeChildOrderExample example);

    @UpdateProvider(type=OutRechargeChildOrderSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(OutRechargeChildOrder record);

    @Update({
        "update out_recharge_child_order",
        "set parent_order_id = #{parentOrderId,jdbcType=BIGINT},",
          "order_no = #{orderNo,jdbcType=VARCHAR},",
          "recharge_platform = #{rechargePlatform,jdbcType=INTEGER},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(OutRechargeChildOrder record);
}