package com.hai.dao;

import com.hai.entity.OutRechargeOrder;
import com.hai.entity.OutRechargeOrderExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface OutRechargeOrderMapper extends OutRechargeOrderMapperExt {
    @SelectProvider(type=OutRechargeOrderSqlProvider.class, method="countByExample")
    long countByExample(OutRechargeOrderExample example);

    @DeleteProvider(type=OutRechargeOrderSqlProvider.class, method="deleteByExample")
    int deleteByExample(OutRechargeOrderExample example);

    @Delete({
        "delete from out_recharge_order",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into out_recharge_order (recharge_price, `type`, ",
        "operator_name, operator_type, ",
        "order_no, recharge_type, ",
        "mem_discount_id, mem_discount_name, ",
        "user_id, user_name, ",
        "user_phone, goods_id, ",
        "recharge_content, pay_type, ",
        "labor_union_card, integral_num, ",
        "discount_deduction_price, integral_deduction_price, ",
        "pay_price, pay_real_price, ",
        "pay_serial_no, create_timed, ",
        "pay_time, cancel_time, ",
        "finish_time, out_refund_no, ",
        "order_price, refund_time, ",
        "tp_refund_order_no, refund_id, ",
        "refund_fee, company_id, ",
        "pay_status, merch_id, ",
        "recharge_status, ext_1, ",
        "ext_2, ext_3)",
        "values (#{rechargePrice,jdbcType=DECIMAL}, #{type,jdbcType=INTEGER}, ",
        "#{operatorName,jdbcType=VARCHAR}, #{operatorType,jdbcType=INTEGER}, ",
        "#{orderNo,jdbcType=VARCHAR}, #{rechargeType,jdbcType=INTEGER}, ",
        "#{memDiscountId,jdbcType=BIGINT}, #{memDiscountName,jdbcType=VARCHAR}, ",
        "#{userId,jdbcType=BIGINT}, #{userName,jdbcType=VARCHAR}, ",
        "#{userPhone,jdbcType=VARCHAR}, #{goodsId,jdbcType=BIGINT}, ",
        "#{rechargeContent,jdbcType=VARCHAR}, #{payType,jdbcType=INTEGER}, ",
        "#{laborUnionCard,jdbcType=VARCHAR}, #{integralNum,jdbcType=DECIMAL}, ",
        "#{discountDeductionPrice,jdbcType=DECIMAL}, #{integralDeductionPrice,jdbcType=DECIMAL}, ",
        "#{payPrice,jdbcType=DECIMAL}, #{payRealPrice,jdbcType=DECIMAL}, ",
        "#{paySerialNo,jdbcType=VARCHAR}, #{createTimed,jdbcType=TIMESTAMP}, ",
        "#{payTime,jdbcType=TIMESTAMP}, #{cancelTime,jdbcType=TIMESTAMP}, ",
        "#{finishTime,jdbcType=TIMESTAMP}, #{outRefundNo,jdbcType=VARCHAR}, ",
        "#{orderPrice,jdbcType=DECIMAL}, #{refundTime,jdbcType=TIMESTAMP}, ",
        "#{tpRefundOrderNo,jdbcType=VARCHAR}, #{refundId,jdbcType=VARCHAR}, ",
        "#{refundFee,jdbcType=DECIMAL}, #{companyId,jdbcType=BIGINT}, ",
        "#{payStatus,jdbcType=INTEGER}, #{merchId,jdbcType=VARCHAR}, ",
        "#{rechargeStatus,jdbcType=INTEGER}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(OutRechargeOrder record);

    @InsertProvider(type=OutRechargeOrderSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(OutRechargeOrder record);

    @SelectProvider(type=OutRechargeOrderSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="recharge_price", property="rechargePrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="operator_type", property="operatorType", jdbcType=JdbcType.INTEGER),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="recharge_type", property="rechargeType", jdbcType=JdbcType.INTEGER),
        @Result(column="mem_discount_id", property="memDiscountId", jdbcType=JdbcType.BIGINT),
        @Result(column="mem_discount_name", property="memDiscountName", jdbcType=JdbcType.VARCHAR),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_name", property="userName", jdbcType=JdbcType.VARCHAR),
        @Result(column="user_phone", property="userPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_id", property="goodsId", jdbcType=JdbcType.BIGINT),
        @Result(column="recharge_content", property="rechargeContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="pay_type", property="payType", jdbcType=JdbcType.INTEGER),
        @Result(column="labor_union_card", property="laborUnionCard", jdbcType=JdbcType.VARCHAR),
        @Result(column="integral_num", property="integralNum", jdbcType=JdbcType.DECIMAL),
        @Result(column="discount_deduction_price", property="discountDeductionPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="integral_deduction_price", property="integralDeductionPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="pay_price", property="payPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="pay_real_price", property="payRealPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="pay_serial_no", property="paySerialNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_timed", property="createTimed", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="pay_time", property="payTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="cancel_time", property="cancelTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="finish_time", property="finishTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="out_refund_no", property="outRefundNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="order_price", property="orderPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="refund_time", property="refundTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="tp_refund_order_no", property="tpRefundOrderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="refund_id", property="refundId", jdbcType=JdbcType.VARCHAR),
        @Result(column="refund_fee", property="refundFee", jdbcType=JdbcType.DECIMAL),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
        @Result(column="pay_status", property="payStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="merch_id", property="merchId", jdbcType=JdbcType.VARCHAR),
        @Result(column="recharge_status", property="rechargeStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<OutRechargeOrder> selectByExample(OutRechargeOrderExample example);

    @Select({
        "select",
        "id, recharge_price, `type`, operator_name, operator_type, order_no, recharge_type, ",
        "mem_discount_id, mem_discount_name, user_id, user_name, user_phone, goods_id, ",
        "recharge_content, pay_type, labor_union_card, integral_num, discount_deduction_price, ",
        "integral_deduction_price, pay_price, pay_real_price, pay_serial_no, create_timed, ",
        "pay_time, cancel_time, finish_time, out_refund_no, order_price, refund_time, ",
        "tp_refund_order_no, refund_id, refund_fee, company_id, pay_status, merch_id, ",
        "recharge_status, ext_1, ext_2, ext_3",
        "from out_recharge_order",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="recharge_price", property="rechargePrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="operator_type", property="operatorType", jdbcType=JdbcType.INTEGER),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="recharge_type", property="rechargeType", jdbcType=JdbcType.INTEGER),
        @Result(column="mem_discount_id", property="memDiscountId", jdbcType=JdbcType.BIGINT),
        @Result(column="mem_discount_name", property="memDiscountName", jdbcType=JdbcType.VARCHAR),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_name", property="userName", jdbcType=JdbcType.VARCHAR),
        @Result(column="user_phone", property="userPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_id", property="goodsId", jdbcType=JdbcType.BIGINT),
        @Result(column="recharge_content", property="rechargeContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="pay_type", property="payType", jdbcType=JdbcType.INTEGER),
        @Result(column="labor_union_card", property="laborUnionCard", jdbcType=JdbcType.VARCHAR),
        @Result(column="integral_num", property="integralNum", jdbcType=JdbcType.DECIMAL),
        @Result(column="discount_deduction_price", property="discountDeductionPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="integral_deduction_price", property="integralDeductionPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="pay_price", property="payPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="pay_real_price", property="payRealPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="pay_serial_no", property="paySerialNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_timed", property="createTimed", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="pay_time", property="payTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="cancel_time", property="cancelTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="finish_time", property="finishTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="out_refund_no", property="outRefundNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="order_price", property="orderPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="refund_time", property="refundTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="tp_refund_order_no", property="tpRefundOrderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="refund_id", property="refundId", jdbcType=JdbcType.VARCHAR),
        @Result(column="refund_fee", property="refundFee", jdbcType=JdbcType.DECIMAL),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
        @Result(column="pay_status", property="payStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="merch_id", property="merchId", jdbcType=JdbcType.VARCHAR),
        @Result(column="recharge_status", property="rechargeStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    OutRechargeOrder selectByPrimaryKey(Long id);

    @UpdateProvider(type=OutRechargeOrderSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") OutRechargeOrder record, @Param("example") OutRechargeOrderExample example);

    @UpdateProvider(type=OutRechargeOrderSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") OutRechargeOrder record, @Param("example") OutRechargeOrderExample example);

    @UpdateProvider(type=OutRechargeOrderSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(OutRechargeOrder record);

    @Update({
        "update out_recharge_order",
        "set recharge_price = #{rechargePrice,jdbcType=DECIMAL},",
          "`type` = #{type,jdbcType=INTEGER},",
          "operator_name = #{operatorName,jdbcType=VARCHAR},",
          "operator_type = #{operatorType,jdbcType=INTEGER},",
          "order_no = #{orderNo,jdbcType=VARCHAR},",
          "recharge_type = #{rechargeType,jdbcType=INTEGER},",
          "mem_discount_id = #{memDiscountId,jdbcType=BIGINT},",
          "mem_discount_name = #{memDiscountName,jdbcType=VARCHAR},",
          "user_id = #{userId,jdbcType=BIGINT},",
          "user_name = #{userName,jdbcType=VARCHAR},",
          "user_phone = #{userPhone,jdbcType=VARCHAR},",
          "goods_id = #{goodsId,jdbcType=BIGINT},",
          "recharge_content = #{rechargeContent,jdbcType=VARCHAR},",
          "pay_type = #{payType,jdbcType=INTEGER},",
          "labor_union_card = #{laborUnionCard,jdbcType=VARCHAR},",
          "integral_num = #{integralNum,jdbcType=DECIMAL},",
          "discount_deduction_price = #{discountDeductionPrice,jdbcType=DECIMAL},",
          "integral_deduction_price = #{integralDeductionPrice,jdbcType=DECIMAL},",
          "pay_price = #{payPrice,jdbcType=DECIMAL},",
          "pay_real_price = #{payRealPrice,jdbcType=DECIMAL},",
          "pay_serial_no = #{paySerialNo,jdbcType=VARCHAR},",
          "create_timed = #{createTimed,jdbcType=TIMESTAMP},",
          "pay_time = #{payTime,jdbcType=TIMESTAMP},",
          "cancel_time = #{cancelTime,jdbcType=TIMESTAMP},",
          "finish_time = #{finishTime,jdbcType=TIMESTAMP},",
          "out_refund_no = #{outRefundNo,jdbcType=VARCHAR},",
          "order_price = #{orderPrice,jdbcType=DECIMAL},",
          "refund_time = #{refundTime,jdbcType=TIMESTAMP},",
          "tp_refund_order_no = #{tpRefundOrderNo,jdbcType=VARCHAR},",
          "refund_id = #{refundId,jdbcType=VARCHAR},",
          "refund_fee = #{refundFee,jdbcType=DECIMAL},",
          "company_id = #{companyId,jdbcType=BIGINT},",
          "pay_status = #{payStatus,jdbcType=INTEGER},",
          "merch_id = #{merchId,jdbcType=VARCHAR},",
          "recharge_status = #{rechargeStatus,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(OutRechargeOrder record);
}