package com.hai.service.impl;

import com.hai.dao.BsDistributionRebateMapper;
import com.hai.dao.BsDistributionUserRelMapper;
import com.hai.entity.BsDistributionRebate;
import com.hai.entity.BsDistributionUserRel;
import com.hai.entity.BsDistributionUserRelExample;
import com.hai.service.BsDistributionUserRelService;
import org.apache.commons.collections4.MapUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service("bsDistributionUserRelService")
public class BsDistributionUserRelServiceImpl implements BsDistributionUserRelService {

    @Resource
    private BsDistributionUserRelMapper  bsDistributionUserRelMapper;

    @Override
    public void insertDistributionRebate(Long userId, String userName , Long popularizeUserId) {

        // 定义分销关联关系
        BsDistributionUserRel distributionUserRel = new BsDistributionUserRel();

        // 查询推广员信息
        Map<String, Object> map = new HashMap<>();
        map.put("userId" , popularizeUserId);

        BsDistributionUserRel popularizeUser = findDistributionUserRel(map);

        distributionUserRel.setUserId(userId);
        distributionUserRel.setUserName(userName);
        distributionUserRel.setAgentId(popularizeUser.getAgentId());
        distributionUserRel.setAgentName(popularizeUser.getAgentName());
        distributionUserRel.setPopularizeUserId(popularizeUserId);
        distributionUserRel.setPopularizeUserName(popularizeUser.getUserName());
        distributionUserRel.setCreateTime(new Date());
        distributionUserRel.setUpdateTime(new Date());
        distributionUserRel.setStatus(100);

        bsDistributionUserRelMapper.insert(distributionUserRel);

    }

    @Override
    public List<BsDistributionUserRel> getDistributionUserRelList(Map<String, Object> map) {
        return null;
    }

    @Override
    public BsDistributionUserRel findDistributionUserRel(Map<String, Object> map) {

        BsDistributionUserRelExample example = new BsDistributionUserRelExample();
        BsDistributionUserRelExample.Criteria criteria = example.createCriteria();

        if (MapUtils.getLong(map , "userId") != null) {
            criteria.andUserIdEqualTo(MapUtils.getLong(map , "userId"));
        }

        List<BsDistributionUserRel> list = bsDistributionUserRelMapper.selectByExample(example);

        if (list.size() > 0) {
            return list.get(0);
        }

        return null;
    }
}
